#!/bin/bash
#===============================================================================
#
#          FILE:  create_experiment.sh
# 
#         USAGE:  ./create_experiment.sh 
# 
#   DESCRIPTION:  
# 
#       OPTIONS:  ---
#  REQUIREMENTS:  ---
#          BUGS:  ---
#         NOTES:  ---
#        AUTHOR:   (), 
#       COMPANY:  
#       VERSION:  1.0
#       CREATED:  15/01/24 16:54:10 EET
#      REVISION:  ---
#===============================================================================

start_date=19930101
resol="eORCA12"
levels="75"
restarts_exp="igza"
forcings="ERA5_HRES"

ROOTDIR="$(git rev-parse --show-toplevel)"
echo $ROOTDIR
# DVC_DIR="../../scripts/dvc-cache-de340-dev"

ICDIR="$ROOTDIR/nemo/V40/${resol}_Z${levels}/$restarts_exp"
COMMONDIR="$ROOTDIR/nemo/V40/${resol}_Z${levels}/common"
XIOSDIR="$ROOTDIR/nemo/V40/${resol}_Z${levels}/xios"
SCRIPTDIR="$ROOTDIR/scripts"
FORCINGDIR="$ROOTDIR/SBC/$forcings/$resol"

EXPID=${EXPID:-"exp.${start_date}.${restarts_exp}.${forcings}.`date +%F-%s`"}
echo $EXPID
EXPDIR="$ROOTDIR/nemo/V40/${resol}_Z${levels}/$EXPID"

mkdir $EXPDIR
cp -R "$ICDIR"/* "$EXPDIR"
cp -R $COMMONDIR/* $EXPDIR
cp -R $XIOSDIR/* $EXPDIR
rm $EXPDIR/namelist*
cp $ICDIR/namelist* $EXPDIR
cp $SCRIPTDIR/rebuild.slurm $EXPDIR
cp $SCRIPTDIR/nam_grid_U $EXPDIR 
cp $SCRIPTDIR/nam_grid_V $EXPDIR 
cp $SCRIPTDIR/nam_grid_T $EXPDIR 
cp $SCRIPTDIR/nam_icemod $EXPDIR 

for var in precip q10 qlw qsw slp snow t10 u10 v10; do for year in {1993..2024}; do ln -s ${FORCINGDIR}/${var}_fc00_ERA5_HRES_eO12.smooth_${year}.nc ${EXPDIR}/${var}_y${year}.nc; done; done
# Changing start date
sed -i "s/\(nn_date0\s*=\s*\)[0-9]\{8\}/\1$start_date/" $EXPDIR/namelist_cfg
# Setting parameters to imposed surface boundary condition experiment
sed -i 's/ln_blk.*/ln_blk = .TRUE./'  $EXPDIR/namelist_cfg
sed -i 's/ln_wave.*/ln_wave = .FALSE./'  $EXPDIR/namelist_cfg
sed -i 's/ln_sdw.*/ln_sdw = .FALSE./'  $EXPDIR/namelist_cfg
sed -i 's/ln_tauw.*/ln_tauw = .FALSE./'  $EXPDIR/namelist_cfg
sed -i 's/ln_stcor.*/ln_stcor = .FALSE./'  $EXPDIR/namelist_cfg


# sed -i 's/sn_cfctl%l_runstat.*/sn_cfctl%l_runstat = .TRUE./'  $EXPDIR/namelist_cfg
# sed -i 's/ln_timing_detail.*/ln_timing_detail = .TRUE./'  $EXPDIR/namelist_cfg
sed -i 's/nn_stock .*=.*/nn_stock = -1/'  $EXPDIR/namelist_cfg
sed -i 's/nn_stocklist.*=.*/nn_stocklist = -9999/'  $EXPDIR/namelist_cfg
sed -i 's!\(<variable id="info_level".*>\).*</variable>!\1-2</variable>!' $EXPDIR/iodef.xml


echo $EXPDIR



